/*
 *	main.c
 *
 *	Vvcdosg
 *
 *	* Tue Sep  5 12:30:00 JST 2002 Naoyuki Sawa
 *	- 쐬JnB
 */
#include "clipsmpl.h"

/****************************************************************************
 *	萔E^
 ****************************************************************************/

typedef int FIXED;
#define FIX(n)		((int)((n) * (1 << 16)))
#define INT(f)		(((int)(f)) / (1 << 16))

#define FPS		20			/* t[[g */
#define SEC(s)		((int)(FPS * (s)))	/* b->t[ϊ */

#define GAME_TIME	SEC(99)			/* Q[ */
#define HORIZON_Y	FIX(16)			/* W */

/*  */
typedef struct _SHIP {
	int st;		/* 0:o/1:ʏ/2: */
	int x, y;	/* ʒu(16.16bit) */
	int cnt;	/* ėpJE^ */
} SHIP;
#define SHIP_Y		FIX(15)			/* ͂YW */
#define SHIP_X_MIN	FIX(16)			/* ͂XW(ŏ) */
#define SHIP_X_MAX	FIX(DISP_X - 16)	/* ͂XW(ő) */
#define SHIP_VX		FIX(0.25)		/* ͂̍Eړx */

/* e */
typedef struct _BOMB {
	int st;		/* 0:o/1:E/2: */
	int x, y;	/* ʒu(16.16bit) */
	int vx, vy;	/* x(16.16bit) */
	int cnt;	/* ėpJE^ */
} BOMB;
#define N_BOMBS		6			/* eoő */
#define BOMB_VX_INIT	FIX(0.75)		/* ěox() */
#define BOMB_VY_INIT	FIX(-2.0)
#define BOMB_G		FIX(0.25)		/* ȅd͉x() */
#define BOMB_VY		FIX(0.33)		/* e̗x() */

/*  */
typedef struct _SUBM {
	int st;		/* 0:o/1:ʏ/2: */
	int x, y;	/* ʒu(16.16bit) */
	int vx, vy;	/* x(16.16bit) */
	int cnt;	/* ėpJE^ */
} SUBM;
#define N_SUBMS		9			/* ͏oC */
#define SUBM_X_MIN	FIX(0 - 16)		/* ͍EړE */
#define SUBM_X_MAX	FIX(DISP_X + 16)
#define SUBM_VX_MAX	FIX(1.0)		/* 󃉃C̐͑x */
#define SUBM_VX_RATE	0.8			/* ꃉC[Ȃ邲ƂɒxȂ銄 */
#define SUBM_ITV_MIN	SEC(2.0)		/* ͏oC^[oŏ */
#define SUBM_ITV_MAX	SEC(5.0)		/* ͏oC^[oő */

/* @ */
typedef struct _MINE {
	int st;		/* 0:o/1:ʏ/2: */
	int x, y;	/* ʒu(16.16bit) */
	int vx, vy;	/* x(16.16bit) */
	int cnt;	/* ėpJE^ */
} MINE;
#define N_MINES		10			/* @oő */
#define MINE_VY		FIX(-0.33)		/* @̕㑬x */
#define MINE_ITV_MIN	SEC(1.5)		/* @˃C^[oŏ */
#define MINE_ITV_MAX	SEC(3.0)		/* @˃C^[oő */

/* Q[ZbV */
typedef struct _GAMEINFO {
	int time;		/* c莞 */
	int score;		/* XRA */
	/*  */
	int n_ships;		/* ͎c萔(݂̐͊܂) */
	SHIP ship;		/*  */
	/* e */
	BOMB bombs[N_BOMBS];	/* e */
	/*  */
	int subm_itv;		/* ͏oC^[o */
	SUBM subms[N_SUBMS];	/*  */
	/* @ */
	int mine_itv;		/* @˃C^[o */
	MINE mines[N_MINES];	/* @ */
} GAMEINFO;

CHR chr_ship[1] = {	/*  */
	{ 0x80, 3, 1, 11, 7 },
};
CHR chr_ship_out[1] = {	/* (j) */
	{ 0x83, 3, 1, 11, 7 },
};
CHR chr_bomb[5] = {	/* e */
	{ 0x86, 1, 1, 1, 1 },
	{ 0x87, 1, 1, 1, 1 },
	{ 0x88, 1, 1, 1, 1 },
	{ 0x89, 1, 1, 1, 1 },
	{ 0x8a, 1, 1, 1, 1 },
};
CHR chr_zank[1] = {	/* c@ */
	{ 0x8b, 1, 1, 1, 0 },
};
CHR chr_subm[2][10] = {	/*  */
{
	{ 0x90, 3, 1, 8, 7 },
	{ 0x93, 3, 1, 8, 7 },
	{ 0x96, 3, 1, 8, 7 },
	{ 0x99, 3, 1, 8, 7 },
	{ 0xa0, 3, 1, 8, 7 },
	{ 0xa3, 3, 1, 8, 7 },
	{ 0xa6, 3, 1, 8, 7 },
	{ 0xa9, 3, 1, 8, 7 },
	{ 0xb0, 3, 1, 8, 7 },
	{ 0xb3, 3, 1, 8, 7 },
}, {
	{ 0xc0, 3, 1, 15, 7 },
	{ 0xc3, 3, 1, 15, 7 },
	{ 0xc6, 3, 1, 15, 7 },
	{ 0xc9, 3, 1, 15, 7 },
	{ 0xd0, 3, 1, 15, 7 },
	{ 0xd3, 3, 1, 15, 7 },
	{ 0xd6, 3, 1, 15, 7 },
	{ 0xd9, 3, 1, 15, 7 },
	{ 0xe0, 3, 1, 15, 7 },
	{ 0xe3, 3, 1, 15, 7 },
},
};
CHR chr_subm_out[2][4] = {/* (j) */
{
	{ 0xb6, 3, 1, 8, 7 },
	{ 0xb9, 3, 1, 8, 7 },
	{ 0xf0, 3, 1, 8, 7 },
	{ 0xf3, 3, 1, 8, 7 },
}, {
	{ 0xe6, 3, 1, 15, 7 },
	{ 0xe9, 3, 1, 15, 7 },
	{ 0xf0, 3, 1, 15, 7 },
	{ 0xf3, 3, 1, 15, 7 },
},
};
CHR chr_mine[2] = {	/* @ */
	{ 0xf6, 1, 1, 1, 1 },
	{ 0xf7, 1, 1, 1, 1 },
};
CHR chr_expr[7] = {	/* @() */
	{ 0x8c, 1, 3, 3, 16 },
	{ 0x8d, 1, 3, 3, 16 },
	{ 0x8e, 1, 3, 3, 16 },
	{ 0x8f, 1, 3, 3, 16 },
	{ 0x8e, 1, 3, 3, 16 },
	{ 0x8d, 1, 3, 3, 16 },
	{ 0x8c, 1, 3, 3, 16 },
};

/****************************************************************************
 *	ϐ
 ****************************************************************************/

int errno;

int now;		/* O[o^C} */
int joy;		/* pbh */
int joy_rep[4];		/* pbh㉺ẼI[gs[gJE^ */

int hiscore;		/* nCXRA */
GAMEINFO gi;		/* Q[ZbV */

/****************************************************************************
 *	֐錾
 ****************************************************************************/

void app_init();
void app_exit();
void schedule();
int demo();
void game();
void ship_work();
int ship_disp(int obj);
void bomb_work();
int bomb_disp(int obj);
void subm_work();
int subm_disp(int obj);
void mine_work();
int mine_disp(int obj);

/****************************************************************************
 *	smain
 ****************************************************************************/

void
smain()
{
	/* B */
	app_init();

	/* C[vB */
	for(;;) {
		if(demo() != 0) break;
		game();
	}

	/* N[AbvB
	 * START+SELECTŏIꍇ̓N[Abv͍s܂B
	 */
	app_exit();
}

/****************************************************************************
 *	app_init
 ****************************************************************************/

void
app_init()
{
	/* \ݒB */
	dispmode(1,	/* 1:XvCg\/0:\ */
		 1,	/* 1:eLXg\/0:\ */
		 1,	/* 1:OtBbN\/0:\ */
		 0,	/* 1:eLXgO/0:w */
		 0);	/* wiF(wʕ\Ȃ̂) */
}

/****************************************************************************
 *	app_exit
 ****************************************************************************/

void
app_exit()
{
}

/****************************************************************************
 *	schedule
 ****************************************************************************/

void
schedule()
{
#define PAUSE_STR	"PAUSE!"	/* PAUSEbZ[W */
#define PAUSE_LEN	6		/* PAUSEbZ[W */
#define PAUSE_X		5		/* \ʒu */
#define PAUSE_Y		5		/* \ʒu */

	static unsigned prev;
	       unsigned cur;
	int joy_old, trg, i;

	int pause;
	unsigned char save[PAUSE_LEN];

	pause = 0;
	for(;;) {
		/* [VSYNC҂B */
		if(prev == 0) prev = msec();
		do {
			cur = msec();
		} while((cur - prev) * FPS < 1000); /* (cur-prev)<(1000/FPS)̕ό` */
		prev = cur;

		/* pbhԎ擾B
		 * VvCuł́AgKI[gs[g̔ōsȂ΂܂B
		 */
		joy_old = joy;
		joy = pad() & 0x00ff;
		trg = (joy ^ joy_old) & joy;
		joy |= trg << 8;
		for(i = 0; i < 4; i++) { /* ㉺E(bit0`3)̂݃I[gs[g */
			if(joy & 1 << i) { /* PAD_*ONȂ  */
				joy_rep[i]++;  /* JEgAbv */
				if(joy_rep[i] >= SEC(0.33) && joy_rep[i] & 1) { /* 莞ԉÂA2t[ */
					joy |= 1 << (i + 8); /* gK */
				}
			} else {
				joy_rep[i] = 0; /* JE^NA */
			}
		}

#if 0
		/* IB */
		if(joy & TRG_SELECT) {
			thread_lock();
			pceAppReqExit(0);
			thread_unlock();
			return;
		}
#endif

		/* PAUSEB */
		if(joy & TRG_START) {
			thread_lock();	/* pclSprite*()gpɃXbh؂ւȂ悤 */
			pause ^= 1;	/* PAUSEԐ؂ւ */
			if(pause & 1) {	/* PAUSE IN */
				/* PAUSEbZ[W\̕ޔB */
				for(i = 0; i < PAUSE_LEN; i++) {
					save[i] = pclSpriteBGGetCharacter(0, PAUSE_X + i, PAUSE_Y);
				}
			} else {	/* PAUSE OUT */
				/* PAUSEbZ[W\̕𕜋AB */
				for(i = 0; i < PAUSE_LEN; i++) {
					pclSpriteBGSetCharacter(0, PAUSE_X + i, PAUSE_Y, save[i]);
				}
			}
			thread_unlock();/* pclSprite*()gpÎŃXbh؂ւ */
		}
		if(!(pause & 1)) break;

		/* PAUSEbZ[W_ŕ\B */
		thread_lock();	/* pclSprite*()gpɃXbh؂ւȂ悤 */
		for(i = 0; i < PAUSE_LEN; i++) {
			pclSpriteBGSetCharacter(0, PAUSE_X + i, PAUSE_Y, pause & 2 ? PAUSE_STR[i] : 0);
		}
		pause ^= 2;
		thread_unlock();/* pclSprite*()gpÎŃXbh؂ւ */
	}
	now++;	/* O[o^C}XV */
}

/****************************************************************************
 *	demo
 ****************************************************************************/

int
demo()
{
	int result, x, y;

	/* ʃNAB */
	cls();
	bgcls(-1);
	spcls(0);

	/* ^Cg\B */
	x = (DISP_X - 4 * 6) / 2;
	y = 32;
	symbol(x + 1, y, "SIMPLE", 2, 1);
	symbol(x    , y, "SIMPLE", 2, 2);
	symbol(x - 1, y, "SIMPLE", 2, 3);
	x = (DISP_X - 10 * 4) / 2;
	y += 10;
	symbol(x + 1, y, "  ", 0, 1);
	symbol(x    , y, "  ", 0, 2);
	symbol(x - 1, y, "  ", 0, 3);

	/* XRA\B */
	locate(0, 0);
	siprintf("1P %03d", gi.score);
	locate(10, 0);
	siprintf("HI %03d", hiscore);

	for(;;) {
		schedule();

		/* Q[JnA܂͏IH */
		if(joy & TRG_A     ) { result =  0; break; }
		if(joy & TRG_SELECT) { result = -1; break; }

		/* vvg\B */
		locate(3,  9); printstr(now % SEC(0.75) < SEC(0.5) ? "[ A ] START" : "           ");
		locate(3, 10); printstr(now % SEC(0.75) < SEC(0.5) ? "[SEL] EXIT " : "           ");
	}
	sound(2);

	/* ʃNAB */
	cls();
	bgcls(-1);
	spcls(0);

	return result;
}

/****************************************************************************
 *	game
 ****************************************************************************/

void
game()
{
	int obj, i, j, x, y;
	CHR *chr, *chr1, *chr2;
	SHIP* ship;
	BOMB* bomb;
	SUBM* subm;
	MINE* mine;

	/* JnbZ[W\B */
	cls();
	for(i = 0; i < SEC(2); i++) {
		schedule();
		locate(5, 5);
		if(i % SEC(0.5) >= SEC(0.2)) {
			printstr("READY?");
		} else {
			printstr("      ");
		}
	}

	/* wi`B */
	cls();
	spcls(0);
	bgcls(-1);
	y = 0;
	thread_lock();
	while(y <  2) { for(x = 0; x < 16; x++) pclSpriteBGSetCharacter(0, x, y, 0x00); y++; } /*  */
	while(y < 11) { for(x = 0; x < 16; x++) pclSpriteBGSetCharacter(0, x, y, 0x10); y++; } /*  */
	thread_unlock();

	/* Q[B */
	memset(&gi, 0, sizeof gi);
	gi.time = GAME_TIME;

	/* ͏B */
	gi.n_ships = 3;
	gi.ship.st = 1;
	gi.ship.y = SHIP_Y;
	gi.ship.x = (SHIP_X_MIN + SHIP_X_MAX) / 2;

	/* ͏B */
	memset(gi.subms, 0, sizeof gi.subms);
	for(i = 0, subm = gi.subms; i < N_SUBMS; i++, subm++) {
		subm->y = HORIZON_Y + FIX(7)/**/ + FIX(8) * i; /* [xŒ */
		subm->vx = (int)(SUBM_VX_MAX * pow(SUBM_VX_RATE, i));  /* xŒ(̂ݕω) */
	}
	gi.subm_itv = -1;

	/* @B */
	memset(gi.mines, 0, sizeof gi.mines);
	for(i = 0, mine = gi.mines; i < N_MINES; i++, mine++) {
		mine->vy = MINE_VY;  /* xŒ */
	}
	gi.mine_itv = 0;

	for(;;) {
		schedule();

		/* Ԃ炷B */
		if(gi.time <= 0) break;
		gi.time--;

		/* ͍ďoB */
		if(gi.ship.st == 0) {
			if(--gi.n_ships <= 0) break; /* Q[I[o[ */
			gi.ship.st = 1;
			gi.ship.y = SHIP_Y;
			gi.ship.x = (SHIP_X_MIN + SHIP_X_MAX) / 2;
			/* @SB(vy͈ێ̂ŁAmemset̓_!) */
			for(i = 0, mine = gi.mines; i < N_MINES; i++, mine++) {
				mine->st = 0;
			}
			gi.mine_itv = MINE_ITV_MAX;
		}

		/* ͏oB */
		if(gi.subm_itv > 0) {
			gi.subm_itv--;
		} else {
			if(gi.subm_itv < 0) {
				i = N_SUBMS - 1; /* ŏ̈͕KŐ[ɏo */
			} else {
				i = rnd(N_SUBMS);
			}
			for(j = N_SUBMS - 1; j >= 0; j--) {
				subm = &gi.subms[(i + j) % N_SUBMS];
				if(!subm->st) {
					/* oB */
					subm->st = 1;
					if(rnd(0x100) & 0x80) { /*  */
						subm->x = SUBM_X_MAX;
						subm->vx = -abs(subm->vx);
					} else { /* E */
						subm->x = SUBM_X_MIN;
						subm->vx = abs(subm->vx);
					}
					subm->cnt = 0;
					/* ̃C^[oB */
					gi.subm_itv = SUBM_ITV_MIN + rnd(SUBM_ITV_MAX - SUBM_ITV_MIN + 1);
					break; /* YȂŁI */
				}
			}
		}

		/* @ˁB */
		if(gi.mine_itv > 0) {
			gi.mine_itv--;
		} else {
			/* @̋󂫃GgTB */
			for(i = 0, mine = gi.mines; i < N_MINES; i++, mine++) {
				if(!mine->st) break;
			}
			if(i < N_MINES) { /* 󂫂... */
				/* o̐͂IB */
				i = rnd(N_SUBMS);
				for(j = N_SUBMS - 1; j >= 0; j--) {
					subm = &gi.subms[(i + j) % N_SUBMS];
					if(subm->st) {
						if(SHIP_X_MIN <= subm->x && subm->x <= SHIP_X_MAX) { /* ʓ̐͂̂ݑΏ */
							/* oB */
							mine->st = 1;
							mine->x = subm->x;
							mine->y = subm->y;
							mine->cnt = 0;
							/* ̃C^[oB */
							gi.mine_itv = MINE_ITV_MIN + rnd(MINE_ITV_MAX - MINE_ITV_MIN + 1);
							break; /* YȂŁI */
						}
					}
				}
			}
		}

		/* ړB */
		ship_work();
		bomb_work();
		subm_work();
		mine_work();

		/* e<->͂̓蔻 */
		for(i = 0, bomb = gi.bombs; i < N_BOMBS; i++, bomb++) {
			if(!bomb->st) continue; /* 0:o ̂ݔ΂ */
			/* ẽL擾B */
			if(bomb->y < HORIZON_Y) { /*  */
				chr1 = &chr_bomb[0];
			} else { /*  */
				if(bomb->st == 1) { /* E */
					chr1 = &chr_bomb[1 + bomb->cnt / 2 % 4];
				} else { /*  */
					chr1 = &chr_bomb[4 - bomb->cnt / 2 % 4];
				}
			}
			for(j = 0, subm = gi.subms; j < N_SUBMS; j++, subm++) {
				if(subm->st != 1) continue; /* 1:ʏ ȊO͔΂ */
				/* ͂̃L擾B */
				if(subm->vx < 0) { /*  */
					chr2 = &chr_subm[0][1 + i];
				} else { /* E */
					chr2 = &chr_subm[1][1 + i];
				}
				/* 蔻B */
				if(chhit(INT(bomb->x), INT(bomb->y), chr1, INT(subm->x), INT(subm->y), chr2)) {
					bomb->st = 0; /* o */
					subm->st = 2; /* j */
					subm->cnt = 0;
					gi.score += (j + 1); /* ͂̐[x_ł(0x[X->1x[X) */
					sound(0);
					break;
				}
			}
		}

		/* <->@̓蔻 */
		ship = &gi.ship;
		if(ship->st == 1) { /* 1:ʏ ȊO͔΂ */
			/* ͂̃L擾B */
			chr1 = &chr_ship[0];
			for(i = 0, mine = gi.mines; i < N_MINES; i++, mine++) {
				if(!mine->st) continue; /* 0:o ̂ݔ΂ */
				/* @̃L擾B */
				switch(mine->st) {
				case 1: /* ʏ */
					if(mine->cnt % SEC(1) < 2) {
						chr2 = &chr_mine[1];
					} else {
						chr2 = &chr_mine[0];
					}
					break;
				case 2: /*  */
					chr2 = &chr_expr[mine->cnt / 4];
					break;
				default:
					chr2 = NULL; /* x} */
				}
				/* 蔻B */
				if(chhit(INT(ship->x), INT(ship->y), chr1, INT(mine->x), INT(mine->y), chr2)) {
					ship->st = 2; /* j */
					ship->cnt = 0;
					/* @͏łAp^[p܂B */
					sound(2);
					break;
				}
			}
		}

		/* \B */
		obj = 0;
		obj = ship_disp(obj);
		obj = bomb_disp(obj);
		obj = subm_disp(obj);
		obj = mine_disp(obj);

		/* XRAEԁEc@\B */
		locate(0, 0);
		siprintf("%03dPTS", gi.score);
		locate(10, 0);
		siprintf("TIME%02d", (gi.time + FPS - 1) / FPS);
		x = DISP_X - 4;
		y = DISP_Y - 3;
		chr = &chr_zank[0];
		for(i = 0; i < gi.n_ships - 1; i++) {
			obj = chdisp(obj, x, y, chr);
			x -= 5;
		}

		/* cXvCgNAB */
		spcls(obj);
	}

	/* c@{[iXZB */
	while(gi.n_ships > 1) {
		obj = 0;
		locate(0, 0);
		siprintf("%03dPTS", gi.score);
		x = DISP_X - 4;
		y = DISP_Y - 3;
		chr = &chr_zank[0];
		for(i = 0; i < gi.n_ships - 1; i++) {
			obj = chdisp(obj, x, y, chr);
			x -= 5;
		}
		spcls(obj);

		for(i = 0; i < SEC(1); i++) schedule();

		gi.score += 100;
		gi.n_ships--;
		sound(3);
	}

	/* ŏI_\ESXvCgNAB */
	locate(0, 0);
	siprintf("%03dPTS", gi.score);
	spcls(0);
	for(i = 0; i < SEC(1); i++) schedule();
	sound(2);

	/* IbZ[W\B */
	locate(4, 5);
	if(gi.score > hiscore) {
		hiscore = gi.score;
		printstr("HISCORE!");
	} else {
		printstr("GAMEOVER");
	}
	for(i = 0; i < SEC(3); i++) schedule();
}

/****************************************************************************
 *	ship_work
 ****************************************************************************/

void
ship_work()
{
	SHIP* ship = &gi.ship;
	BOMB* bomb;
	int i;

	if(!ship->st) return;
	switch(ship->st) {
	case 1: /* ʏ */
		/* EړB */
		if(joy & PAD_LF) ship->x -= SHIP_VX;
		if(joy & PAD_RI) ship->x += SHIP_VX;
		if(ship->x < SHIP_X_MIN) ship->x = SHIP_X_MIN;
		if(ship->x > SHIP_X_MAX) ship->x = SHIP_X_MAX;
		/* eoB */
		if(joy & TRG_A) { /* E */
			for(i = 0, bomb = gi.bombs; i < N_BOMBS; i++, bomb++) {
				if(!bomb->st) {
					memset(bomb, 0, sizeof(BOMB));
					bomb->st = 1;
					bomb->x = ship->x + FIX(6);
					bomb->y = ship->y - FIX(4);
					bomb->vx = BOMB_VX_INIT;
					bomb->vy = BOMB_VY_INIT;
					sound(1);
					break;
				}
			}
		}
		if(joy & TRG_B) { /*  */
			for(i = 0, bomb = gi.bombs; i < N_BOMBS; i++, bomb++) {
				if(!bomb->st) {
					memset(bomb, 0, sizeof(BOMB));
					bomb->st = 2;
					bomb->x = ship->x - FIX(6);
					bomb->y = ship->y - FIX(4);
					bomb->vx = -BOMB_VX_INIT;
					bomb->vy = BOMB_VY_INIT;
					sound(1);
					break;
				}
			}
		}
		break;
	case 2: /*  */
		ship->cnt++;
		if(ship->cnt >= 8 * 4 + SEC(2)/*ďoC^[o*/) {
			ship->st = 0;
			break;
		}
		break;
	}
}

/****************************************************************************
 *	ship_disp
 ****************************************************************************/

int
ship_disp(int obj)
{
	SHIP* ship = &gi.ship;
	CHR* chr;

	if(!ship->st) return obj;
	switch(ship->st) {
	case 1: /* ʏ */
		chr = &chr_ship[0];
		obj = chdisp(obj, INT(ship->x), INT(ship->y), chr);
		break;
	case 2: /*  */
		chr = &chr_ship_out[0];
		obj = chdisp(obj, INT(ship->x), INT(ship->y) + ship->cnt / 4, chr);
		break;
	}
	return obj;
}

/****************************************************************************
 *	ship_disp
 ****************************************************************************/

void
bomb_work()
{
	BOMB* bomb;
	int i;

	for(i = 0, bomb = gi.bombs; i < N_BOMBS; i++, bomb++) {
		if(!bomb->st) continue;
		/* xB */
		if(bomb->y < HORIZON_Y) { /*  */
			bomb->vy += BOMB_G;
		} else { /*  */
			bomb->vx = 0;
			bomb->vy = BOMB_VY;
			bomb->cnt++; /* Aj[Vp */
		}
		/* ړB */
		bomb->x += bomb->vx;
		bomb->y += bomb->vy;
		/* ʊOH */
		if(bomb->x < FIX(0) || bomb->x >= FIX(DISP_X) || bomb->y >= FIX(DISP_Y)) {
			bomb->st = 0;
			continue;
		}
	}
}

/****************************************************************************
 *	ship_disp
 ****************************************************************************/

int
bomb_disp(int obj)
{
	BOMB* bomb;
	CHR* chr;
	int i, x, y;

	x = (DISP_X - 4 * (N_BOMBS - 1) + 2) / 2;
	y = 1;
	for(i = 0, bomb = gi.bombs; i < N_BOMBS; i++, bomb++) {
		if(bomb->st) { /* o */
			if(bomb->y < HORIZON_Y) { /*  */
				chr = &chr_bomb[0];
			} else { /*  */
				if(bomb->st == 1) { /* E */
					chr = &chr_bomb[1 + bomb->cnt / 2 % 4];
				} else { /*  */
					chr = &chr_bomb[4 - bomb->cnt / 2 % 4];
				}
			}
			obj = chdisp(obj, INT(bomb->x), INT(bomb->y), chr);
		} else { /* o */
			chr = &chr_bomb[0];
			obj = chdisp(obj, x, y, chr);
			x += 4;
		}
	}

	return obj;
}

/****************************************************************************
 *	subm_work
 ****************************************************************************/

void
subm_work()
{
	SUBM* subm;
	int i;

	for(i = 0, subm = gi.subms; i < N_SUBMS; i++, subm++) {
		if(!subm->st) continue;
		switch(subm->st) {
		case 1: /* ʏ */
			/* ړB */
			subm->x += subm->vx;
			/* ʊOH */
			if(subm->x < SUBM_X_MIN || subm->x > SUBM_X_MAX) {
				subm->st = 0;
				continue;
			}
			break;
		case 2: /* j */
			subm->cnt++;
			if(subm->cnt >= 4 * 2) {
				subm->st = 0;
				break;
			}
			break;
		}
	}
}

/****************************************************************************
 *	subm_disp
 ****************************************************************************/

int
subm_disp(int obj)
{
	SUBM* subm;
	CHR* chr;
	int i;

	for(i = 0, subm = gi.subms; i < N_SUBMS; i++, subm++) {
		if(!subm->st) continue;
		switch(subm->st) {
		case 1: /* ʏ */
			if(subm->vx < 0) { /*  */
				chr = &chr_subm[0][1 + i];
			} else { /* E */
				chr = &chr_subm[1][1 + i];
			}
			obj = chdisp(obj, INT(subm->x), INT(subm->y), chr);
			break;
		case 2: /* j */
			if(subm->vx < 0) { /*  */
				chr = &chr_subm_out[0][subm->cnt / 2];
			} else { /* E */
				chr = &chr_subm_out[1][subm->cnt / 2];
			}
			obj = chdisp(obj, INT(subm->x), INT(subm->y), chr);
			break;
		}
	}

	return obj;
}

/****************************************************************************
 *	mine_work
 ****************************************************************************/

void
mine_work()
{
	MINE* mine;
	int i;

	for(i = 0, mine = gi.mines; i < N_MINES; i++, mine++) {
		if(!mine->st) continue;
		switch(mine->st) {
		case 1: /* ʏ */
			mine->x += mine->vx;
			mine->y += mine->vy;
			mine->cnt++; /* Aj[Vp */
			if(mine->y <= HORIZON_Y) {
				mine->y = HORIZON_Y;
				mine->st = 2;
				mine->cnt = 0;
			}
			break;
		case 2: /*  */
			mine->cnt++;
			mine->cnt++;
			if(mine->cnt >= 7 * 4) {
				mine->st = 0;
				break;
			}
			break;
		}
	}
}

/****************************************************************************
 *	mine_disp
 ****************************************************************************/

int
mine_disp(int obj)
{
	MINE* mine;
	CHR* chr;
	int i;

	for(i = 0, mine = gi.mines; i < N_MINES; i++, mine++) {
		if(!mine->st) continue;
		switch(mine->st) {
		case 1: /* ʏ */
			if(mine->cnt % SEC(1) < 2) {
				chr = &chr_mine[1];
			} else {
				chr = &chr_mine[0];
			}
			obj = chdisp(obj, INT(mine->x), INT(mine->y), chr);
			break;
		case 2: /*  */
			chr = &chr_expr[mine->cnt / 4];
			obj = chdisp(obj, INT(mine->x), INT(mine->y), chr);
			break;
		}
	}

	return obj;
}
