/*	
 *	clipsmpl.c
 *
 *	VvCuT|[g[`W
 *	Copyright (C) 2002 Naoyuki Sawa
 *
 *	RAAPIpCLiPCuƂ͕pł܂B
 *
 *	* Sat Sep  7 18:26:00 JST 2002 Naoyuki Sawa
 *	- 쐬JnB
 */
#include "clipsmpl.h"

/****************************************************************************
 *	spcls
 ****************************************************************************/

void
spcls(int obj)
{
	while(obj < N_OBJS) sppos(obj++, -8, -8);
}

/****************************************************************************
 *	bgcls
 ****************************************************************************/

void
bgcls(int color)
{
	unsigned char mask, bit1, bit0;
	unsigned char* p;
	int y;

	switch(color) {
	case  0: bit1 = 0x00; bit0 = 0x00; mask = 0x00; break;
	case  1: bit1 = 0x00; bit0 = 0xff; mask = 0x00; break;
	case  2: bit1 = 0xff; bit0 = 0x00; mask = 0x00; break;
	case  3: bit1 = 0xff; bit0 = 0xff; mask = 0x00; break;
	default: bit1 = 0x00; bit0 = 0x00; mask = 0xff; break;
	}
	/*thread_lock();ȂĂv*/
	p = pclSpriteBGGetFrameAdr(1);
	/*thread_unlock();ȂĂv*/
	for(y = 0; y < 256; y++) {
		memset(p, bit1, 256 / 8); p += 256 / 8;
		memset(p, bit0, 256 / 8); p += 256 / 8;
		memset(p, mask, 256 / 8); p += 256 / 8;
	}
}

/****************************************************************************
 *	paint
 ****************************************************************************/

/* * Sat Jul 20 08:18:00 JST 2002 Naoyuki Sawa
 * - L^CX^v̎_łrender_paint()x[XɁAVvCupɈڐA܂B
 *   ڐAɍۂăRg͏CĂ܂̂ŁAꕔAAPIgpz肵RgcĂ܂B
 * - hԂFێϐucv̌^ɒӁI
 *   APIprender_paint()łunsigned charłAVvCułintłB
 *   point()͓lƂ-1Ԃ̂ŁAintŕێĂȂƓ̓hԂł܂B
 */

/* SĂ܂BxłB
 * Q[ł́AhԂvʂ͏ȂƎv̂ŁA
 * ̂܂܂łɖ͂ȂƎv܂B
 */
void
paint(int x0, int y0, int color)
{
/* hԂ_X^bNTCYF
 * ƂAȂ蕡GȓhԂł24xłA
 * Ô߁A]TŁA傫߂ɎĂƂɂ܂B
 * ܂傫ƁAP/ECEł̓X^bNӂ̂ŁAӂB
 */
#define RENDER_PAINT_STACK_SIZE	64

/* r[|[gTCYF
 * ʂɌĂ镔(DISP_X~DISP_Y)ł͂ȂA
 * OtBbNʑŜ̃TCY(256~256)Ƃ܂B
 */
#define VP_LEFT		  0
#define VP_RIGHT	256
#define VP_TOP		  0
#define VP_BOTTOM	256

	short stack[RENDER_PAINT_STACK_SIZE][2]; /* ߖ̂short */
	int i_stack, x, y, x1, x2;
	int c; /* APIłunsigned charłAVvCułintłĨRgQ */

	/* hԂJn_r[|[gOȂA܂B */
	if(x0 < VP_LEFT || VP_RIGHT  - 1 < x0) return;
	if(y0 < VP_TOP  || VP_BOTTOM - 1 < y0) return;

	/* hԂF擾܂B */
	c = point(x0, y0);

	/* hԂJn_ɓhԂFȂA܂B */
	/* if(c == color) return; */
	/* ->悭lÃ`FbN͕svłB
	 *   hԂJn_ɓhԂFȂA
	 *   1. X^bNɍŏ(x0,y0)ςށB
	 *   2. while()[v̒(x0,y0)oB
	 *   3. ɓhĂ̂ŁAcontinueŔ΂B
	 *   4. X^bN͋Ȃ̂ŁAIB
	 *   ƂȂAɏI܂B
	 */

	/* hԂJn_X^bNɐς݂܂B */
	stack[0][0] = x0;
	stack[0][1] = y0;
	i_stack = 1;

	/* hԂ_ȂȂ܂... */
	while(i_stack != 0) {
		/* hԂ_o܂B */
		i_stack--;
		x0 = stack[i_stack][0];
		y0 = stack[i_stack][1];

		/* ɓhĂA΂܂B */
		if(point(x0, y0) == color) continue;

		/* hF̍[T܂B */
		x1 = x0;
		for(;;) {
			x1--;
			if(x1 < VP_LEFT) break; /* r[|[gO */
			if(point(x1, y0) != c) break; /* ʐF */
		}
		x1++; /* s߂Ă̂Ŗ߂ */

		/* hF̉E[T܂B */
		x2 = x0;
		for(;;) {
			x2++;
			if(x2 > VP_RIGHT - 1) break; /* r[|[gO */
			if(point(x2, y0) != c) break; /* ʐF */
		}
		x2--; /* s߂Ă̂Ŗ߂ */

		/* E̊ԂhԂ܂B */
		for(x = x1; x <= x2; x++) {
			pset(x, y0, color);
			/* pceLCDTrans()ĂԂƁAhԂ̗lq1sNZPʂŊώ@ł܂B */
			/* pceLCDTrans() */
		}
		/* pceLCDTrans()ĂԂƁAhԂ̗lq1CPʂŊώ@ł܂B */
		/* pceLCDTrans() */

		/* ̃C̒B */
		if(y0 != VP_TOP) {
			y = y0 - 1;
			x = x1;
			for(;;) {
				/* hF̎n܂T܂B */
				for(;;) {
					if(x > x2) break;
					if(point(x, y) == c) break;
					x++;
				}
				if(x > x2) break; /* Ȃ */

				/* hF̏IT܂B */
				for(;;) {
					if(x > x2) break;
					if(point(x, y) != c) break;
					x++;
				}

				/* hF̏ÏʒuX^bNɐς݂܂B */
				if(i_stack < RENDER_PAINT_STACK_SIZE) {
					stack[i_stack][0] = x - 1; /* s߂Ă̂Ŗ߂ */
					stack[i_stack][1] = y;
					i_stack++;
				}
			}
		}

		/* ̃C̒B */
		if(y0 != VP_BOTTOM - 1) {
			y = y0 + 1;
			x = x1;
			for(;;) {
				/* hF̎n܂T܂B */
				for(;;) {
					if(x > x2) break;
					if(point(x, y) == c) break;
					x++;
				}
				if(x > x2) break; /* Ȃ */

				/* hF̏IT܂B */
				for(;;) {
					if(x > x2) break;
					if(point(x, y) != c) break;
					x++;
				}

				/* hF̏ÏʒuX^bNɐς݂܂B */
				if(i_stack < RENDER_PAINT_STACK_SIZE) {
					stack[i_stack][0] = x - 1; /* s߂Ă̂Ŗ߂ */
					stack[i_stack][1] = y;
					i_stack++;
				}
			}
		}
	}

#undef RENDER_PAINT_STACK_SIZE
#undef VP_LEFT
#undef VP_RIGHT
#undef VP_TOP
#undef VP_BOTTOM
}

/****************************************************************************
 *	sphit
 ****************************************************************************/

/* XvCgm̃sNZPʂ̓蔻s܂B
 * [in]
 *	(x1,y1),pno1	XvCg1̍Wƃp^[ԍ
 *	(x2,y2),pno2	XvCg2̍Wƃp^[ԍ
 * [out]
 *	߂l		Ȃ1AOȂ0Ԃ܂B
 * [note]
 *	* 蔻́AXvCgp^[̃}XNgčs܂B
 *	  ̃XvCgp^[̃}XN1sNZłdȂĂ΁A
 *	  ƌȂ܂B
 */
int
sphit(int x1, int y1, int pno1, int x2, int y2, int pno2)
{
	extern unsigned char PAT[];

	int i;
	unsigned char *p1, *p2;
	unsigned short mask1, mask2;

	/* ܂ȔB */
	if(x1 + 8 - 1 < x2) return 0; /* XvCg1XvCg2荶 */
	if(y1 + 8 - 1 < y2) return 0; /* XvCg1XvCg2 */
	if(x2 + 8 - 1 < x1) return 0; /* XvCg1XvCg2E */
	if(y2 + 8 - 1 < y1) return 0; /* XvCg1XvCg2艺 */

	/* XvCgp^[AhXvZB */
	p1 = &PAT[(pno1 & 0xff/*Ô*/) * 8 * 3/*bit1,bit0,mask*/];
	p2 = &PAT[(pno2 & 0xff/*Ô*/) * 8 * 3/*bit1,bit0,mask*/];

	/* eCł̃sNZPʂ̓蔻B */
	if(y1 <= y2) {
		i = y2 - y1;
		p1 += i * 3;
	} else {
		i = y1 - y2;
		p2 += i * 3;
	}
	if(x1 <= x2) {
		x2 -= x1;
		      x1 = 0;
	} else {
		x1 -= x2;
		      x2 = 0;
	}
	do {
		/* ӁFXvCgf[^0:s/1: */
		mask1 = (p1[2/*mask*/] ^ 0xff) << x1;
		mask2 = (p2[2/*mask*/] ^ 0xff) << x2;
		if(mask1 & mask2) return 1;
		p1 += 3;
		p2 += 3;
	} while(++i < 8);

	return 0;
}

/****************************************************************************
 *	chdisp
 ****************************************************************************/

/* ̃XvCg\AL\܂B
 * [in]
 *	obj		ŏ̃XvCgv[ԍ
 *	x, y		L̒SW
 *	chr		L\̂ւ̃|C^
 * [out]
 *	߂l		Ō̃XvCgv[ԍ{P
 * [note]
 *	* spdisp()ւ̈64zXvCgv[ԍw肵ꍇA
 *	  spdisp()ɏԂdlɈˑĂ܂B
 *	  chdisp()֐g̓XvCgv[ԍ͈̔͂lĂ܂B
 */
int
chdisp(int obj, int x, int y, const CHR* chr)
{
	int col, row, pno;

	/* SWւ̃ItZbgA_W炵܂B */
	x -= chr->x;
	y -= chr->y;

	/* L\AeXvCg\܂B */
	for(row = 0; row < chr->h; row++) {
		for(col = 0; col < chr->w; col++) {
			pno = chr->pno + 0x10 * row + col;
			spdisp(obj++, x + col * 8, y + row * 8, pno);
		}
	}

	return obj;
}

/****************************************************************************
 *	chhit
 ****************************************************************************/

/* Lm̃sNZPʂ̓蔻s܂B
 * [in]
 *	(x1,y1),chr1	L1̍Wƃp^[ԍ
 *	(x2,y2),chr1	L2̍Wƃp^[ԍ
 * [out]
 *	߂l		Ȃ1AOȂ0Ԃ܂B
 * [note]
 *	* sphit()[note]QƂĂB
 */
int
chhit(int x1, int y1, const CHR* chr1, int x2, int y2, const CHR* chr2)
{
	int col1, row1, pno1, col2, row2, pno2;

	/* SWւ̃ItZbgA_W炵܂B */
	x1 -= chr1->x;
	y1 -= chr1->y;
	x2 -= chr2->x;
	y2 -= chr2->y;

	/* ܂ȔB */
	if(x1 + chr1->w * 8 - 1 < x2) return 0; /* L1L2荶 */
	if(y1 + chr1->h * 8 - 1 < y2) return 0; /* L1L2 */
	if(x2 + chr2->w * 8 - 1 < x1) return 0; /* L1L2E */
	if(y2 + chr2->h * 8 - 1 < y1) return 0; /* L1L2艺 */

	/* L1ƃL2̑SXvCg̑蔻B */
	for(row1 = 0; row1 < chr1->h; row1++) {
		for(col1 = 0; col1 < chr1->w; col1++) {
			pno1 = chr1->pno + 0x10 * row1 + col1;
			for(row2 = 0; row2 < chr2->h; row2++) {
				for(col2 = 0; col2 < chr2->w; col2++) {
					pno2 = chr2->pno + 0x10 * row2 + col2;
					if(sphit(x1 + col1 * 8, y1 + row1 * 8, pno1,
						 x2 + col2 * 8, y2 + row2 * 8, pno2)) return 1;
				}
			}
		}
	}

	return 0;
}
